unit Ecessoes;

{Exception - Exceo genrica, usada apenas como ancestral de todas as outras excees
EAbort - Exceo silenciosa, pode ser gerada pelo procedimento Abort e no mostra nenhuma mensagem
EAccessViolation - Acesso invlido  memria, geralmente ocorre com objetos no inicializados
EConvertError - Erro de converso de tipos
EDivByZero - Diviso de inteiro por zero
EInOutError - Erro de Entrada ou Sada reportado pelo sistema operacional
EIntOverFlow - Resultado de um clculo inteiro excedeu o limite
EInvalidCast - TypeCast invlido com o operador as
EInvalidOp - Operao invlida com nmero de ponto flutuante
EOutOfMemory - Memria insuficiente
EOverflow - Resultado de um clculo com nmero real excedeu o limite
ERangeError - Valor excede o limite do tipo inteiro ao qual foi atribuda
EUnderflow - Resultado de um clculo com nmero real  menor que a faixa vlida
EVariantError - Erro em operao com variant
EZeroDivide - Diviso de real por zero
EDatabaseError - Erro genrico de banco de dados, geralmente no  usado diretamente
EDBEngineError - Erro da BDE, descende de EDatabaseError e traz dados que podem identificar o erro}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    OcorrenciaNormalTryFinally: TButton;
    OcorrenciaNormalAninhada: TButton;
    excecaoDividir: TButton;
    ExcecaoInstanciar: TButton;
    procedure OcorrenciaNormalTryFinallyClick(Sender: TObject);
    procedure OcorrenciaNormalAninhadaClick(Sender: TObject);
    procedure excecaoDividirClick(Sender: TObject);
    procedure ExcecaoInstanciarClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{Nesse Exemplo, temos uma ocorrncia normal da Aplicao utilizando Try,
Finally -> Try, Except . O cdigo na clusula Try  executado por completo
e em seguida, o cdigo da clusula Finally  executado entrando primeiro
na clusula Try que est dentro de Finally, como no  gerada nenhuma
exceo dentro desse Try o cdigo  executado por completo indo em seguida para a ltima linha do Finally.}

procedure TForm1.OcorrenciaNormalTryFinallyClick(Sender: TObject);
var
  resultado, dividendo, divisor: Integer;
  MinhaStringlist: TStringList;
begin
  try
    // Atribuimos valor a uma propriedade do objeto aps
    // ele ser instanciado. Isso Pode!.
    MinhaStringlist := TStringList.Create;
    MinhaStringlist.Text := '1';

    dividendo := StrToInt(MinhaStringlist.Strings[0]);
    divisor := 1;
    resultado := dividendo div divisor;

    MinhaStringlist.Clear;
    MinhaStringlist.Add(IntToStr(resultado));
    ShowMessage('O resultado : ' + MinhaStringlist.Text);

  finally
    try
      MinhaStringlist.Destroy;
      ShowMessage('Tudo Certo!');
    except
      ShowMessage('O Aplicativo tentou destruir um'
        + 'Objeto que no estava instnciado');
    end;
    Application.Terminate;
  end;
end;

{Nesse Exemplo, temos uma ocorrncia normal da Aplicao utilizando Try -> Try,
Except, Finally -> Try, Except. O cdigo na clusula Try -> Try  executado por
completo e em seguida, o cdigo da clusula Finally  executado entrando primeiro
na clusula Try que est dentro de Finally, como no  gerada nenhuma exceo
dentro desse Try o cdigo  executado por completo indo em seguida para a ltima linha do Finally.
}

procedure TForm1.OcorrenciaNormalAninhadaClick(Sender: TObject);
var
  resultado, dividendo, divisor: Integer;
  MinhaStringlist: TStringList;
begin
  try
    try
      // Atribuimos valor a uma propriedade do objeto aps
      // ele ser instanciado. Isso Pode!.
      MinhaStringlist := TStringList.Create;
      MinhaStringlist.Text := '1';

      dividendo := StrToInt(MinhaStringlist.Strings[0]);
      divisor := 1;
      resultado := dividendo div divisor;

      MinhaStringlist.Clear;
      MinhaStringlist.Add(IntToStr(resultado));
      ShowMessage('O resultado : ' + MinhaStringlist.Text);
      //-----------------------------------------------------
    except
      on EDivByZero do
        ShowMessage('No  permitido dividir por '
          + QuotedStr('0'));
      on EAccessViolation do
        ShowMessage('Ocorreu Violao de Acesso');
    else
      ShowMessage('No deu nada Certo');
    end;
    //-----------------------------------------------------
  finally
    try
      MinhaStringlist.Destroy;
      ShowMessage('Tudo Certo!');
    except
      ShowMessage('O Aplicativo tentou destruir um'
        + 'Objeto que no estava instnciado');
      ShowMessage('J que deu tudo errado eu vou embora');
    end;
    Application.Terminate;
  end;
end;

{Nesse Exemplo temos uma ocorrncia de uma diviso por zero na Aplicao utilizando
Try -> Try, Except, Finally -> Try, Except. O cdigo na clusula Try -> Try  executado
at a linha "resultado := dividendo div divisor;", como nessa linha ocorre a exceo
"EDivByZero" o cdigo da clusula Except  executado verificando o tipo de exceo que
foi gerado, repare que nesse exemplo o Except possui apenas 3 tentativas (on EDivByZero do,
on EAccessViolation do e else), a tentativa vlida que ser executada  on EDivByZero
do e aps isso o finally  chamado executando o cdigo da mesma forma como mostramos nos exemplos anteriores.}

procedure TForm1.excecaoDividirClick(Sender: TObject);
var
  resultado, dividendo, divisor: Integer;
  MinhaStringlist: TStringList;
begin
  try
    try
      // Atribuimos valor a uma propriedade do objeto aps
      // ele ser instanciado. Isso Pode!.
      MinhaStringlist := TStringList.Create;
      MinhaStringlist.Text := '1';

      dividendo := StrToInt(MinhaStringlist.Strings[0]);
      divisor := 0;

      //EDivByZero ocorre nessa linha
      resultado := dividendo div divisor;

      MinhaStringlist.Clear;
      MinhaStringlist.Add(IntToStr(resultado));
      ShowMessage('O resultado : ' + MinhaStringlist.Text);
      //-----------------------------------------------------
    except
      // Aps a exceo gerada em try
      // alinha abaixo ser executada
      on EDivByZero do
        ShowMessage('No  permitido dividir por '
          + QuotedStr('0'));
      on EAccessViolation do
        ShowMessage('Ocorreu Violao de Acesso');
    else
      ShowMessage('No deu nada Certo');
    end;
    //-----------------------------------------------------
  finally
    try
      MinhaStringlist.Destroy;
      ShowMessage('Tudo Certo!');
    except
      ShowMessage('O Aplicativo tentou destruir um'
        + 'Objeto que no estava instnciado');
      ShowMessage('J que deu tudo errado eu vou embora');
    end;
    Application.Terminate;
  end;
end;

{ Nesse Exemplo, temos a ocorrncia de um objeto que no criado, ou instancializado se preferir,
ser utilizado para atribuio de valor em Try -> Try, Except, Finally -> Try, Except. O cdigo na
clusula Try -> Try  executado at a linha "MinhaStringList.Text := '1';",
como o objeto MinhaStringList no foi criado ("MinhaStringList := TStringList.Create;"),
essa linha gera a exceo "EAccessViolation", ento, o cdigo da clsula Except  executado
verificando o tipo de exceo que foi gerado, executando a linha on EAccessViolation do e
aps isso o finally  chamado executando o cdigo da clusula Try que por sua vez tambm gera uma exceo.
A exceo ocorre porque tentamos destruir um objeto que no foi Criado, linha "MinhaStringList.Destroy;".
Assim o cdigo em Except  executado e aps isso o restante do cdigo do finally  executado. }

procedure TForm1.ExcecaoInstanciarClick(Sender: TObject);
var
  resultado, dividendo, divisor: Integer;
  MinhaStringlist: TStringList;
begin
  try
    try
      // Atribuimos valor a uma propriedade do objeto aps
      // ele ser instanciado.
      //Access Vioaltion ocorre nessa linha
      MinhaStringlist.Text := '1';
      MinhaStringlist := TStringList.Create;

      divisor := 0;
      MinhaStringlist.Text := IntToStr(StrToInt(MinhaStringlist.Text) div divisor);
    except
      on EDivByZero do
        ShowMessage('No  permitido dividir por '
          + QuotedStr('0'));
      // Depois do Access Violation n o try
      // a linha abaixo ser executada
      on EAccessViolation do
        ShowMessage('Ocorreu Violao de Acesso');
    else
      ShowMessage('No deu nada Certo');
    end;
  finally
    try
      // Outro acces violation nessa linha
      MinhaStringlist.Destroy;
      Application.Terminate;
    except
      on EDivByZero do
        ShowMessage('No  permitido dividir por '
          + QuotedStr('0'));
      // Depois do Access Violation n o try
      // a linha abaixo ser executada
      on EAccessViolation do
        ShowMessage('Ocorreu Violao de Acesso');
    else
      ShowMessage('No deu nada Certo');
    end;
 end;
end;
end.

